import grails.converters.*

class ClassController {

	def index = {
	  switch(request.method){
	    case "POST":
	    	post(params)
	    	break
	    case "GET":
	    	get(params)
	        break
	    case "PUT":
	    	put(params)
	    	break
	    case "DELETE":
	    	delete(params)
	    	break
	  }   
	}
	
	def post(params) {
		def cuClass = CuClass.findByCallNumber(params.cuClass.callNumber)
	    cuClass.properties = params.cuClass
	    if(cuClass.save()){
	        response.status = 200 // OK
	        render cuClass as XML
	    }
	    else{
	        response.status = 500 //Internal Server Error
	        render "Could not update CuClass due to errors:\n ${cuClass.errors}"
	    }
	}
	
	def get(params) {
		if (params.callNumber) {
	    	render CuClass.findByCallNumber(params.callNumber) as XML
	    }
	    else {
	    	render CuClass.list() as XML
	    }  
	}
	
	def delete(params) {
		if(params.callNumber){
            def cuClass = CuClass.findByCallNumber(params.callNumber)
            if(cuClass){
            	cuClass.delete()
              render "Successfully Deleted ${params.callNumber}\n"
            }
            else{
              response.status = 404 //Not Found
              render "${params.callNumber} not found.\n"
            }
         }
         else{
            response.status = 400 //Bad Request
            render "DELETE request must include the Call Number\n Example: /class/CSCI7818 \n"
         }
	}
	
	def put(params) {
		def cuClass = new CuClass(params.cuClass)
	      if(cuClass.save()){
	        response.status = 201 // Created
	        render cuClass as XML
	      }
	      else{
	        response.status = 500 //Internal Server Error
	        render "Could not create new CuClass due to errors:\n ${cuClass.errors}"
	      }
	}
}
